#include <stdio.h>
#include <opus.h>

void     main(argc,argv)
int      argc;
char     *argv[];

{
char     *on;
int      i,j,k;
static struct   _sched recs[35];
static struct   _time when[35];
FILE     *infp;

       if (argc>1) infp=fopen(argv[1],"rb");

       else infp=fopen("SCHED.BBS","rb");

       if (infp){
                 k = fread((char *)recs,34,35,infp);
                 printf("[2J");

                 printf("\n\nEvent Tag  Day   Start  Length");
                 printf(" Run?     Exit  Mail  LO  CM  SX  MO  FR\n");

                 for (i=0;i<=34;i++){

                     when[i]=recs[i].time;
                     k=when[i].daywk;

                        if (recs[i].enable == 1) on="ENA";
                        if (recs[i].enable == 0) on="DEL";
                        if (recs[i].enable>1 || recs[i].enable<0) on="DIS";

                     printf("\n %3u%4c",
                     i,recs[i].tag);

                     dow(k);
                     j=when[i].mins %10;
                     k=(when[i].mins -j)/10;

                     printf("%4u:%1u%1u%8u%5s",when[i].hour,k,j,
                     recs[i].len,on);

                     if (recs[i].event_mask & FORCE_EVENT)
                        printf("  F");
                     else (printf("   "));

                     if (recs[i].tag == 'X') printf("%5u",recs[i].result);
                     if (recs[i].tag == 'Y') printf("%5u",recs[i].result);

                     k=recs[i].behavior;
                     if (recs[i].result ==1) behave(k);
                     if (recs[i].result ==2) printf("      House cleaning");

                 }
         printf("\n\n\n");
         }
         else (printf("\n\n\t Bad read of file!\n\n\n"));

         fclose(infp);

}

dow(k)
int   k;

{
char    *days;
                   switch (k) {

                         case 0:days="SUN";
                              break;
                         case 1:days="MON";
                              break;
                         case 2:days="TUE";
                              break;
                         case 3:days="WED";
                              break;
                         case 4:days="THU";
                              break;
                         case 5:days="FRI";
                              break;
                         case 6:days="SAT";
                              break;
                         case 7:days="ALL";
                              break;
                         default:days="ALL";
                         }
                  printf("%6s",days);
                  return;
}

behave(k)
int      k;

{
char    yep  = 'Y', no = 'N';

     if (k & NO_TRAFFIC) printf("%12c",no);
     else printf("%12c",yep);
     if (k & LOCAL_ONLY) printf("%5c",yep);
     else printf("%5c",no);
     if (k & OPUS_ONLY) printf("%4c",yep);
     else printf("%4c",no);
     if (k & NO_EXITS) printf("%4c",yep);
     else printf("%4c",no);
     if (k & MAIL_ONLY) printf("%4c",yep);
     else printf("%4c",no);
     if (k & TAKE_REQ) printf("%4c",yep);
     else printf("%4c",no);
     return;
}
